using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Mvc.Ajax;
using WindowsLive;
using Microsoft.ServiceHosting.ServiceRuntime;

namespace TheCIAPickup_WebRole.Controllers
{
    public class AuthenticationController : Controller
    {
        public ActionResult Handle()
        {
            string action = Request.Params["action"];
            var wll = new WindowsLiveLogin(RoleManager.GetConfigurationSetting("wlappid"), RoleManager.GetConfigurationSetting("wlsecret"));
            if (action == "logout")
            {
                HttpCookie loginCookie = new HttpCookie("webauthtoken");
                loginCookie.Expires = DateTime.Now.AddYears(-10);
                Response.Cookies.Add(loginCookie);

                return RedirectToAction("index", "home");
            }
            else if (action == "clearcookie")
            {
                HttpCookie loginCookie = new HttpCookie("webauthtoken");
                loginCookie.Expires = DateTime.Now.AddYears(-10);
                Response.Cookies.Add(loginCookie);

                string type;
                byte[] content;
                wll.GetClearCookieResponse(out type, out content);
                return new FileContentResult(content, type);
            }
            else
            {
                WindowsLiveLogin.User user = wll.ProcessLogin(Request.Form);
                HttpCookie loginCookie = new HttpCookie("webauthtoken");
                if (user != null)
                {
                    loginCookie.Value = user.Token;

                    if (user.UsePersistentCookie)
                    {
                        loginCookie.Expires = DateTime.Now.AddYears(10);
                    }
                }
                else
                {
                    loginCookie.Expires = DateTime.Now.AddYears(-10);
                }
                Response.Cookies.Add(loginCookie);
                return RedirectToAction("index", "home");
            }
        }
    }
}