using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using System.Web.Mvc.Ajax;
using DataModels;
using System.Net.Mail;
using Microsoft.Samples.ServiceHosting.StorageClient;
using System.Net;
using Microsoft.ServiceHosting.ServiceRuntime;

namespace TheCIAPickup_WebRole.Controllers
{
    public class TwilioController : Controller
    {
        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult Index()
        {
            return Content("<?xml version=\"1.0\" encoding=\"UTF-8\"?><Response><Say>Welcome to the Central Intelligence Agency automated phone system.  If you have an emergency, please hang up and dial 9 1 1.</Say><Gather numDigits=\"5\" action=\"/twilio/ain\" method=\"POST\"><Say>To be connected to an agent, please enter a five digit agent identification number.</Say></Gather></Response>", "text/xml", System.Text.Encoding.UTF8);
        }
        [AcceptVerbs(HttpVerbs.Post)]
        public ActionResult Ain(string Digits, string Caller, string AccountSid)
        {
            if (AccountSid != RoleManager.GetConfigurationSetting("TwilioAccountSid"))
            {
                return Content("<?xml version=\"1.0\" encoding=\"UTF-8\"?><Response><Say>Security error.  Account Sid doesn't match.</Say></Response>");
            }
            var context = new CIAContext();
            Agent agent = null;
            try
            {
                agent = context.AgentTable.Where(a => a.PartitionKey == int.Parse(Digits).ToString() && a.RowKey == string.Empty).First();
            }
            catch (Exception e)
            {
                HttpStatusCode status;
                StorageExtendedErrorInformation extendedErrorInfo;
                if (!TableStorageHelpers.EvaluateException(e, out status, out extendedErrorInfo) || extendedErrorInfo.ErrorCode != StorageErrorCodeStrings.ResourceNotFound)
                {
                    throw;
                }
            }
            if (agent == null)
            {
                return Content("<?xml version=\"1.0\" encoding=\"UTF-8\"?><Response><Say>That is not a valid Agent Identification Number.  Please hang up and try again.</Say></Response>");
            }
            QueueStorage.Create(StorageAccountInfo.GetDefaultQueueStorageAccountFromConfiguration()).GetQueue("callqueue").PutMessage(new Message(string.Format("{0}/{1}/{2}", agent.PartitionKey, Caller, DateTime.UtcNow.Ticks)));
            return Content(string.Format("<?xml version=\"1.0\" encoding=\"UTF-8\"?><Response><Say>Agent {0} is currently unavailable to take your call.  Please hang up and try again later.</Say></Response>", agent.Name), "text/xml", System.Text.Encoding.UTF8);
        }
    }
}